#ifndef ANIME_H
#define ANIME_H
#include "config.h"
#include "obj_draw.h"

typedef enum {
    am_single,
    am_repeat,
} anime_mode_t;

typedef enum {
    af_img_static,
    af_img_dynamic,
    af_loop,
    af_reset_pos,
    af_end
} anime_fragment_type_t;


typedef struct {
	image_id_t iid;
	int num;
	int offset_x, offset_y;
} anime_param_img_t;

typedef struct {
	int offset;
	int num;
} anime_param_loop_t;

typedef struct {
    anime_fragment_type_t type;
    struct {
		int param1, param2, param3, param4;
    } param;
	int ctr;
} anime_fragment_t;

#define AnimeParamImgIid(f) (((anime_param_img_t*)(&(f)->param))->iid)
#define AnimeParamImgNum(f) (((anime_param_img_t*)(&(f)->param))->num)
#define AnimeParamImgOffsetX(f) (((anime_param_img_t*)(&(f)->param))->offset_x)
#define AnimeParamImgOffsetY(f) (((anime_param_img_t*)(&(f)->param))->offset_y)
#define AnimeParamLoopOffset(f) (((anime_param_loop_t*)(&(f)->param))->offset)
#define AnimeParamLoopNum(f) (((anime_param_loop_t*)(&(f)->param))->num)
	

typedef struct {
    obj_type_t obj_type;
    void (*draw_func)(int x, int y, int frag_no, int frame_no);
    int base_x, base_y;
    anime_fragment_t *fragments;

    int current_fragment_ix;
    int x, y;
} anime_sequence_t;




void anime_init(void);
void reset_anime_sequence(anime_sequence_t *seq);
image_id_t interpret_anime_sequence(anime_sequence_t *seq, anime_mode_t mode);
int draw_anime_sequence(anime_sequence_t *seq, anime_mode_t mode);
int skip_anime(anime_sequence_t *seq, int step);
int draw_anime_array(anime_sequence_t *seq[], anime_mode_t mode);
void reset_anime_array(anime_sequence_t *seq[]);
int skip_anime_array(anime_sequence_t *seq[], int step);
#ifdef LOCK_STAGE
int is_anime_locked(anime_sequence_t *seq);
int is_anime_array_locked(anime_sequence_t *seq[]);
#endif


#endif
