/*
  カスタマイズ可能なパラメータ
*/
#ifndef CONFIG_H
#define CONFIG_H
#include <assert.h>

// emap表示など、デバッグ用機能を有効にする
//#define DEBUG
// 未クリアのステージは挑戦可能な分以外はロックする
//#define LOCK_STAGE

#define MAJOR_VERSION 0
#define MINOR_VERSION 51

#define SAVE_DIR ".gondin"
#define ACHIEVEMENTS_FILE "gondin.dat"
#define CONFIG_FILE "gondin.cfg"
#define STAGE_DIR "stage"
#define STAGE_RECORD_DIR "record"
#define CAMPAIGN_DIR "campaign"
#define CUSTOM_DIR "custom"

#define STAGE_RECORD_EXT "sav"
#define STAGE_EXT "stg"


#define LOG_FILE "gondin.log"
#define LOG_OUTPUT_STDERR_DEFAULT 1
#define LOG_OUTPUT_FILE_DEFAULT 1
#define LOG_LIMIT (1024*1024)

#define APPLICATION_ID "\000Gondin\000"
#define APPLICATION_ID_SIZE 8

#define GAME_SPEED 50
//#define DEAD_SPEED (GAME_SPEED*5)
#define DEAD_SPEED (GAME_SPEED*5)
#define GAME_FPS (1000/GAME_SPEED)

// ステージ内に存在できるオブジェクト数の上限
#define OBJ_NUM_MAX 4096

// ステージ数の上限とその桁数
#define STAGE_NUM_MAX 999
#define STAGE_NUM_LEN 3
#define SCORE_LEN 6
#define STAR_NUM_LEN 3

// ステージ開始時にリンク波及を安定させるために回すターン数
#define SETUP_TURN 16

// 1ターンにキューに貯め込めるオブジェクト間の状態変更要求数
#define OBJ_STATE_REQ_MAX 1024



// アニメーション再生速度係数(指定したフレーム毎に1コマ更新)
#define ANIME_SLOWDOWN 1
// アニメスキップ時に何フレームずつ進めるか
#define ANIME_SKIP_STEP 8


#endif

