#include <stdio.h>
#include <EzGraph.h>
#include "config.h"
#include "gameend.h"
#include "gameclear_draw.h"
#include "draw.h"
#include "game.h"
#include "stage.h"
#include "file.h"

static gameend_menuitem_t cursor_pos;

void gameend_init(void){
}

void setup_gameend(void){
   	EzSetKeyHandler(gameend_keyh);
	EzSetKeyReleaseHandler(gameend_key_releaseh);
	if (!jump_key_released){
		puts("setup gameend");
		has_space_released = 0;
	}
}
void setup_gameclear(void){
    int i;
	puts("setup gameclear");
    game.score_time = GAME_TIME_SCORE * GetTime();
    game.score_gondin = GONDIN_SCORE * GetGondinEaten();
    SetGameRecord(re_score, game.score_time + game.score_gondin);
    for (i = 0 ; i < OBJECTIVE_NUM ; i++){
        if (game.objectives[i].op != oo_none){
            if (game.objectives[i].stat == st_sofar){
                game.objectives[i].stat = st_done;
				game.objectives[i].stat_fontseq[0] = fi_check;
            }
            if (game.objectives[i].stat == st_done){
                printf("objective %d done\n", i);
                AddGameRecord(re_score, OBJECTIVE_SCORE);
            }
        }
    }
	IncGameRecord(re_clear); // 総クリア数を1増やすため
	update_stage_record(&game);
	save_current_stage_record(get_current_stage_name());
    switch_draw_gameclear(1);
    cursor_pos = gi_quit;
    setup_gameend();
	setup_gameclear_draw();
}
void setup_gameover(void){
    switch_draw_gameover(1);
    cursor_pos = gi_retry;
    setup_gameend();
    // 死因を+1した結果を保存しておく
	// それ以外のgame.recordは反映させないのでupdate_stage_record()は呼ばない
	save_current_stage_record(get_current_stage_name());
}



gameend_menuitem_t gameend_cmd(void){
    //	printf("cursor pos:%d\n", cursor_pos);
	return cursor_pos;
}


void gameend_keyh(int key){
    switch (key){
	case EZ_Left:
        printf("EZ_Left keyh %d\n", cursor_pos);
		cursor_pos = (gameend_menuitem_t)((cursor_pos+gi_end-1) % gi_end);
		break;
	case EZ_Right:
        printf("EZ_Right keyh %d\n", cursor_pos);
		cursor_pos = (gameend_menuitem_t)((cursor_pos+1) % gi_end);
		break;
	default:
		break;
	}
}
void gameend_key_releaseh(int key){
    switch (key){
	case ' ':
		if (has_space_released == 0){
			break;
		}
		// gameendに入ってから押したのであれば、このまま以下の処理を開始
	case 13:
		EzSetKeyHandler(game_keyh);
		EzSetKeyReleaseHandler(game_key_releaseh);
		switch (cursor_pos){
		case gi_retry:
	        retry_game();
			break;
		case gi_quit:
	        quit_game();
			break;
		default:
			assert(0);
			break;
		}
		break;
	case 'r':
		EzSetKeyHandler(game_keyh);
		EzSetKeyReleaseHandler(game_key_releaseh);
        retry_game();
		break;
	case 'q':
		EzSetKeyHandler(game_keyh);
		EzSetKeyReleaseHandler(game_key_releaseh);
        quit_game();
		break;
	default:
		break;
	}
}


