#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <EzGraph.h>
#include "config.h"
#include "obj.h"
#include "obj_draw.h"
#include "obj_siguku.h"
#include "emap.h"

void create_siguku(obj_t *obj, int ox, int oy, dir_t dir){
    obj->width = SIGUKU_WIDTH;
    obj->height = SIGUKU_HEIGHT;
//	SetAttr(obj, at_item);
	SetAttr(obj, at_immune_water);
	SetAttr(obj, at_turn_to_mist);
    obj->motion = ii_siguku;
}

int set_action_siguku(obj_t *obj){
    int v;

    switch (State(obj)){
    case os_none:
    case os_blasted:
        // 落下中やふっとばされ中に生き物に当たると消える
        v = check_emap_pos_box_any(Ltx(obj), Lty(obj),
                                   SIGUKU_WIDTH, SIGUKU_HEIGHT,
		                           EM_MEAT | EM_VEGETABLE);
        if (v){
            //            SetState(obj, os_dead);
            SetState(obj, os_siguku_splashing);
        }
        else if (check_creature_landed(obj) && !IsSliding(obj)){
            printf("drop landed\n");
            SetState(obj, os_siguku_landed);
        }
        break;
    case os_siguku_landed:
        if (IsSliding(obj)){
	        SetState(obj, os_none);
            break;
        }
        if (check_emap_box_any(Ltx(obj), Rby(obj)+1, obj->width, 1, EM_ICE)){
            printf("create ice\n");
            SetState(obj, os_siguku_freezing);
            return 0;
        }
        else if (check_creature_landed(obj)){
	        SetState(obj, os_siguku_splashing);
			break;
        }
        SetState(obj, os_none);
		break;
    case os_siguku_splashing:
		// 地面に落ちて消える場合は死亡カウントしない
//		SetState(obj, os_dead);
		return 1;
    case os_siguku_freezing:
		IncCtr(obj);
		if (Ctr(obj) >= FREEZE_COUNT){
	        printf("CREATE ICE\n");
            // 現在座標に近いグリッド位置にiwallを生成
            // @note グリッドは4座標単位刻みなので、+2してから切り捨てることで一捨二入している
		    create_obj(ot_iwall, (obj->x+2) & 0xfffc, (obj->y+2) & 0xfffc, di_none);
		// 凍る場合は死亡カウントしない
            return 1;
		}
		break;
    default:
        break;
    }
    return 0;
}

void set_motion_siguku(obj_t *obj){
    if (BlastX(obj)){
        obj->dir = (BlastX(obj) < 0) ? di_left : di_right;
    }
    switch (State(obj)){
	SkipDefaultCreatureMotions;
	case os_siguku_freezing:
        SetMotion(obj, ii_siguku_freezing);
        break;
	case os_siguku_splashing:
        SetMotion(obj, ii_siguku_splash);
        break;
    default:
        SetMotion(obj, ii_siguku);
        break;
    }
}

void set_emap_siguku(obj_t *obj){
    set_emap_creature(obj);
    set_emap_box(obj->x, obj->y, obj->width, obj->height, EM_WATER);
}

