#include <stdio.h>
#include <EzGraph.h>
#include "config.h"
#include "main.h"
#include "stage_info.h"
#include "stage_info_draw.h"
#include "record.h"

static int info_num;
static int offset;

void stage_info_init(void){
    info_num = get_record_showentry_num();
}

void setup_stage_info(void){
    EzSetKeyHandler(stage_info_keyh);
    EzSetKeyReleaseHandler(stage_info_key_releaseh);
    EzSetTimerHandler(stage_info_timerh, GAME_SPEED);
    setup_stage_info_draw();
    printf("setup stage info\n");
    offset = 0;
}

void stage_info_keyh(int key){
    int offset_max = info_num - STAGE_INFO_LINE_NUM + 1;
    switch (key){
    case EZ_Left:
    case EZ_Up:
        offset = (offset + offset_max - 1) % offset_max;
        break;
    case EZ_Right:
    case EZ_Down:
        offset = (offset + 1) % offset_max;
        break;
    default:
        break;
    }
}

void stage_info_key_releaseh(int key){
    switch (key){
    case 'q':
	case 27:
    case ' ':
    case EZ_Return:
        set_main_state(ms_select_stage);
        break;
    default:
        break;
    }
}

void stage_info_timerh(void){
    draw_stage_info(offset);
}



