#include <stdio.h>
#include <EzGraph.h>

#include "config.h"
#include "layout.h"
#include "title.h"
#include "draw.h"
#include "title_draw.h"
#include "font.h"
#include "obj_draw.h"
#include "anime.h"

#include "xpm/title.xpm"

static EzImage title_img;

static char *title_str = "ご　ん　で　ぃ　ん";
static font_id_t *title_fontseq;

static char *item_strs[ti_end] = {
	"げーむ",
	"せつめい",
//	"えでぃた",
//	"せってい",
	"おわる",
};

#define ITEM_NUM (sizeof(item_strs)/sizeof(char*))
static font_id_t **item_fontseqs;

#define TITLE_DEMO_OFFSET_X (WIN_WIDTH/DRAW_SCALE/2)
#define TITLE_DEMO_OFFSET_Y 72


static anime_fragment_t interval_frags[] =
    {
		{af_img_static, {ii_none, 80, 0, 0}},
		{af_end},
    };
static anime_fragment_t chee_walk_frags[] =
    {
		{af_img_static, {ii_chee_walk_l0, 2, -1, 0}},
		{af_img_static, {ii_chee_walk_l1, 2, -1, 0}},
        {af_loop,       {-2, 84}},
		{af_img_static, {ii_chee_walk_r0, 2,  1, 0}},
		{af_img_static, {ii_chee_walk_r1, 2,  1, 0}},
        {af_loop,       {-2, 84+24}},
		{af_end},
    };
static anime_fragment_t chee_run_frags[] =
    {
		{af_img_static, {ii_chee_walk_l0, 2, -1, 0}},
		{af_img_static, {ii_chee_walk_l1, 2, -1, 0}},
        {af_loop,       {-2, 84}},
		{af_img_static, {ii_chee_walk_r0, 1,  1, 0}},
		{af_img_static, {ii_chee_walk_r1, 1,  1, 0}},
        {af_loop,       {-2, 84+24}},
		{af_end},
    };
static anime_fragment_t chee_panic_run_frags[] =
    {
		{af_img_static, {ii_chee_walk_l0, 2, -1, 0}},
		{af_img_static, {ii_chee_walk_l1, 2, -1, 0}},
        {af_loop,       {-2, 84}},
		{af_img_static, {ii_chee_wander_r0, 1,  1, 0}},
		{af_img_static, {ii_chee_wander_r1, 1,  1, 0}},
        {af_loop,       {-2, 84+24}},
		{af_end},
    };
static anime_fragment_t chee_flame_frags[] =
    {
		{af_img_static, {ii_none, 84*2*2, 0, 0}},
		{af_img_static, {ii_flame_l, 1, 1, 0}},
        {af_loop,       {-1, 84*2+24}},
		{af_end},
    };
static anime_fragment_t yaramasi_chase_frags[] =
    {
		{af_img_static, {ii_none, 2*2*84+12, 0, 0}},
		{af_img_static, {ii_yaramasi_walk_r0, 1,  1, 0}},
		{af_img_static, {ii_yaramasi_walk_r1, 1,  1, 0}},
        {af_loop,       {-2, 84}},
		{af_end},
    };
static anime_fragment_t jumeme_chase_frags[] =
    {
		{af_img_static, {ii_none, 2*2*84+11, 0, 0}},
		{af_img_static, {ii_jumeme_walk_r0, 1,  1, 0}},
		{af_img_static, {ii_jumeme_walk_r1, 1,  1, 0}},
        {af_loop,       {-2, 84}},
		{af_end},
    };
static anime_fragment_t hatopo_chase_frags[] = {
		{af_img_static, {ii_none, 2*2*84+12+4, 0, 0}},
		{af_img_static, {ii_hatopo_walk_r0, 2,  1, 0}},
		{af_img_static, {ii_hatopo_walk_r1, 2,  1, 0}},
        {af_loop,       {-2, 84}},
		{af_end},
    };
static anime_fragment_t chee_wander_frags[] =
    {
		{af_img_static, {ii_chee_walk_l0, 2, -1, 0}},
		{af_img_static, {ii_chee_walk_l1, 2, -1, 0}},
        {af_loop,       {-2, 84}},
		{af_img_static, {ii_chee_wander_r0, 3,  1, 0}},
		{af_img_static, {ii_chee_wander_r1, 3,  1, 0}},
        {af_loop,       {-2, 84+24}},
		{af_end},
    };
static anime_fragment_t ojigiri_wander_frags[] = 
    {
		{af_img_static, {ii_none, (2+2)*84, 0, 0}},
		{af_img_static, {ii_ojigiri_l, 3, 1-2, 0}},
		{af_img_static, {ii_ojigiri_l, 3, 1, 0}},
		{af_img_static, {ii_ojigiri_r, 3, 1+2, 0}},
		{af_img_static, {ii_ojigiri_r, 3, 1, 0}},
        {af_loop,       {-4, 84/2}},
		{af_end},
    };
/*
static anime_fragment_t hatopo_walk_frags[] = {
		{af_img_static, {ii_hatopo_walk_l0, 2, -1, 0}},
		{af_img_static, {ii_hatopo_walk_l1, 2, -1, 0}},
        {af_loop,       {-2, 84}},
		{af_img_static, {ii_hatopo_walk_r0, 2,  1, 0}},
		{af_img_static, {ii_hatopo_walk_r1, 2,  1, 0}},
        {af_loop,       {-2, 84}},
		{af_end},
    };
*/
static anime_fragment_t chee_bow_frags[] =
    {
		{af_img_static, {ii_chee_walk_l0, 2, -1, 0}},
		{af_img_static, {ii_chee_walk_l1, 2, -1, 0}},
        {af_loop,       {-2, 42}},
        {af_img_static, {ii_chee_init, 16, 0, 0}},
        {af_img_static, {ii_chee_bow, 16, 0, 0}},
        {af_img_static, {ii_chee_init, 32, 0, 0}},
		{af_img_static, {ii_chee_walk_r0, 2,  1, 0}},
		{af_img_static, {ii_chee_walk_r1, 2,  1, 0}},
        {af_loop,       {-2, 42}},
		{af_end},
    };
/*
static anime_fragment_t test_frags[] =
    {
        {af_img_static, {ii_chee_init, 16, 0, 0}},
        {af_img_static, {ii_chee_bow, 16, 0, 0}},
        {af_img_static, {ii_chee_init, 40, 0, 0}},
        {af_img_static, {ii_none, 8, 0, 0}},
        {af_loop,       {-4, 10}},
		{af_end},
    };
*/
/*
static anime_fragment_t mingo_chase_frags[] =
    {
		{af_img_static, {ii_mingo_walk_l0, 1, -1, 0}},
		{af_img_static, {ii_mingo_walk_l1, 1, -1, 0}},
		{af_img_static, {ii_mingo_walk_l2, 1, -1, 0}},
		{af_img_static, {ii_mingo_walk_l3, 1, -1, 0}},
        {af_loop,       {-4, 42}},
		{af_img_static, {ii_mingo_walk_r0, 1,  1, 0}},
		{af_img_static, {ii_mingo_walk_r1, 1,  1, 0}},
		{af_img_static, {ii_mingo_walk_r2, 1,  1, 0}},
		{af_img_static, {ii_mingo_walk_r3, 1,  1, 0}},
        {af_loop,       {-4, 42}},
		{af_end},
    };
*/
static anime_fragment_t chee_blast_frags[] =
    {
		{af_img_static, {ii_chee_walk_l0, 2, -1, 0}},
		{af_img_static, {ii_chee_walk_l1, 2, -1, 0}},
        {af_loop,       {-2, 84}},
		{af_img_static, {ii_chee_blast_l, 1,  2, 0}},
        {af_loop,       {-1, 160}},
		{af_img_static, {ii_none, 60, 0, 0}},
		{af_end},
    };
static anime_fragment_t gagga_kyupin_frags[] =
    {
		{af_img_static, {ii_none, (2+2)*85, 0, 0}},
        {af_img_static, {ii_bang8_8, 2, 8, 0}},
		{af_img_static, {ii_none, 86, -8, 0}},
		{af_img_static, {ii_gagga_attack_r1, 1, 1, 0}},
        {af_loop,       {-1, 6}},
		{af_img_static, {ii_gagga_attack_r0, 2, 0, 0}},
		{af_img_static, {ii_gagga_init,     10, 0, 0}},
		{af_img_static, {ii_gagga_kyupin0,   5, 0, 0}},
		{af_img_static, {ii_gagga_kyupin1,  40, 0, 0}},
		{af_end},
    };


static anime_sequence_t interval_seq = {
    ot_none, NULL, 0, 0, interval_frags, 0, 0, 0
};
static anime_sequence_t chee_walk_seq = {
    ot_chee, NULL, 84, 0, chee_walk_frags, 0, 0, 0
};
static anime_sequence_t chee_run_seq = {
    ot_chee, NULL, 84, 0, chee_run_frags, 0, 0, 0
};
static anime_sequence_t chee_panic_run_seq = {
    ot_chee, NULL, 84, 0, chee_panic_run_frags, 0, 0, 0
};
static anime_sequence_t chee_flame_seq = {
    ot_flame, NULL, -92, 1, chee_flame_frags, 0, 0, 0
};
static anime_sequence_t hatopo_chase_seq = {
    ot_hatopo, NULL, -88, 0, hatopo_chase_frags, 0, 0, 0
};
static anime_sequence_t yaramasi_chase_seq = {
    ot_yaramasi, NULL, -88, 4, yaramasi_chase_frags, 0, 0, 0
};
static anime_sequence_t jumeme_chase_seq = {
    ot_jumeme, NULL, -88, 0, jumeme_chase_frags, 0, 0, 0
};
static anime_sequence_t chee_wander_seq = {
    ot_chee, NULL, 84, 0, chee_wander_frags, 0, 0, 0
};
static anime_sequence_t ojigiri_wander_seq = {
    ot_ojigiri, NULL, -88+1, -16+1, ojigiri_wander_frags, 0, 0, 0
};
static anime_sequence_t chee_blast_seq = {
    ot_chee, NULL, 84, 0, chee_blast_frags, 0, 0, 0
};
static anime_sequence_t gagga_kyupin_seq = {
    ot_gagga, NULL, -88, 0, gagga_kyupin_frags, 0, 0, 0
};



//static anime_sequence_t hatopo_walk_seq = {
//    ot_hatopo, NULL, 84, 0, hatopo_walk_frags, 0, 0, 0
//};
static anime_sequence_t chee_bow_seq = {
    ot_chee, NULL, 84, 0, chee_bow_frags, 0, 0, 0
};
//static anime_sequence_t mingo_chase_seq = {
//    ot_mingo, NULL, 84+8, 0, mingo_chase_frags, 0, 0, 0
//};
//static anime_sequence_t test_seq = {
//    ot_none, NULL, 0, 0, test_frags, 0, 0, 0
//};
static anime_sequence_t *anime_sequences[] = {
    &interval_seq,
    &chee_walk_seq,
    &chee_run_seq,
    &chee_panic_run_seq,
    &chee_flame_seq,
    &hatopo_chase_seq,
    &yaramasi_chase_seq,
    &jumeme_chase_seq,
    &chee_bow_seq,
    &chee_wander_seq,
    &ojigiri_wander_seq,
    &chee_blast_seq,
    &gagga_kyupin_seq,

    //    &hatopo_walk_seq,
    //    &mingo_chase_seq,
    //    &test_seq,
};
#define ANIME_SEQUENCE_NUM (sizeof(anime_sequences)/sizeof(anime_sequence_t*))

static anime_sequence_t *anime_interval[] = {&interval_seq, NULL};
static anime_sequence_t *anime_chee_walk[] = {&chee_walk_seq, NULL};
static anime_sequence_t *anime_hatopo_chase[] = {
    &chee_walk_seq, &hatopo_chase_seq, NULL
};
static anime_sequence_t *anime_yaramasi_chase[] = {
    &chee_run_seq, &yaramasi_chase_seq, NULL
};
static anime_sequence_t *anime_chee_bow[] = {&chee_bow_seq, NULL};
static anime_sequence_t *anime_chee_wander[] = {
     &ojigiri_wander_seq, &chee_wander_seq, NULL
};

static anime_sequence_t *anime_gagga_kyupin[] = {
    &chee_blast_seq, &gagga_kyupin_seq, NULL
};
static anime_sequence_t *anime_jumeme_chase[] = {
    &chee_panic_run_seq, &chee_flame_seq, &jumeme_chase_seq, NULL
};




//static anime_sequence_t *anime_chee_run[] = {&chee_run_seq, NULL};




//static anime_sequence_t *anime_hatopo_walk[] = {&hatopo_walk_seq, NULL};
//static anime_sequence_t *anime_mingo_chase[] = {
//    &mingo_chase_seq, &chee_walk_seq, NULL
//};
//static anime_sequence_t *anime_test[] = {&test_seq, NULL};

static anime_sequence_t **animes[] = {
    anime_interval,
    anime_chee_walk,
    anime_interval,
    anime_chee_bow,
    anime_interval,
    anime_hatopo_chase,
    anime_interval,
    anime_yaramasi_chase,
    anime_interval,
    anime_gagga_kyupin,	
	anime_interval,
    anime_interval,
    anime_chee_wander,
    anime_jumeme_chase,
    anime_interval,


	/*
	anime_chee_run,
    anime_interval,
    anime_hatopo_walk,
    anime_interval,
    anime_mingo_chase,
    anime_interval,
    anime_test,
	*/
};

#define ANIME_NUM (sizeof(animes)/sizeof(anime_sequence_t**))
static int anime_no;

/*
static int anime_sequence_no;
*/
void title_draw_init(void){
	int i;

    assert(ti_end == ITEM_NUM);

    title_img = EzReadXPM(title_xpm);
    title_fontseq = alloc_fontseq(title_str);
    item_fontseqs = alloc_fontseq_array(ITEM_NUM);
	for (i = 0 ; i < ITEM_NUM ; i++){
		item_fontseqs[i] = alloc_fontseq(item_strs[i]);
	}

    for (i = 0 ; i < ANIME_SEQUENCE_NUM ; i++){
        anime_sequences[i]->base_x += TITLE_DEMO_OFFSET_X;
        anime_sequences[i]->base_y += TITLE_DEMO_OFFSET_Y;
        reset_anime_sequence(anime_sequences[i]);
    }
    anime_no = 0;

    /*
    test_fontseqs = alloc_fontseq_array(ITEM_NUM);
	for (i = 0 ; i < ITEM_NUM ; i++){
		test_fontseqs[i] = alloc_fontseq(test_strs[i]);
	}
    */
}

void draw_title(void){
	int i;

    EzPutB((WIN_WIDTH-397)/2, 24, title_img);
    draw_fontseq((WIN_WIDTH-16*9)/2, 192, title_fontseq);
	for (i = 0 ; i < ITEM_NUM ; i++){
        draw_fontseq((WIN_WIDTH-16*4)/2, 320+i*LINESKIP, item_fontseqs[i]);
	}
    draw_img(ii_chee16_wr0,
             RDX(WIN_WIDTH-16*4)/2-3,
             RDY(320+get_title_cursor_pos()*LINESKIP));
    draw_title_demo();
	EzShowBuffer();
    /*
    str2fontseq(str_title, msg);
    draw_fontseq((SCREEN_WIDTH-16*5)/2, 240, msg);
    str2fontseq(str_test, msg);
    draw_fontseq((SCREEN_WIDTH-16*5)/2, 260, msg);

    for (i = 0 ; i < ITEM_NUM ; i++){
        draw_fontseq((SCREEN_WIDTH-16*5)/2, 400+i*20, test_fontseqs[i]);
    }	
    */
}

void draw_title_demo(void){
    if (draw_anime_array(animes[anime_no], am_single)){
        proceed_title_demo();
    }
}




void proceed_title_demo(void){
#ifdef LOCK_STAGE
    // すべてのanimesがlockedはないことを想定
    do {
        anime_no ++;
        if (anime_no >= ANIME_NUM) anime_no = 0;
        printf("anime No.%d\n", anime_no);
    } while (is_anime_array_locked(animes[anime_no]));
#else
    anime_no ++;
    if (anime_no >= ANIME_NUM) anime_no = 0;
#endif
    printf("proceed to anime No.%d\n", anime_no);
    reset_anime_array(animes[anime_no]);
}

void skip_title_demo(void){
    if (skip_anime_array(animes[anime_no], ANIME_SKIP_STEP)){
        proceed_title_demo();
    }
}
